routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Use App\Http\Controllers\Admin\UserController as AdminUserController;
Use App\Http\Controllers\Admin\CommentController as AdminCommentController;
Use App\Http\Controllers\Admin\PictureController as AdminPictureController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::middleware('language')->group(function () {

    Auth::routes();
    Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('pictures', \App\Http\Controllers\PictureController::class)->except('edit', 'update');

    Route::resource('users', \App\Http\Controllers\UserController::class)->only('show', 'edit', 'update');

    Route::resource('comments', \App\Http\Controllers\CommentController::class)->except('index', 'create');






Route::prefix('admin')->name('admin.')->middleware(['auth', 'is_admin'])->group(function () {
    Route::resources([
        'users' => AdminUserController::class,
        'comments' => AdminCommentController::class,
        'pictures' => AdminPictureController::class
    ]);
});


Route::post('/admin/{user}/admin', [AdminUserController::class, 'admin'])->name('admin.users.admin');

});
Route::get('language/{local}', [\App\Http\Controllers\LanguageSwitchController::class, 'switcher'])->name('language.switcher')->where('locale', 'en|ru|es|fr|kg');

app/Models/Picture.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static find($input)
 */
class Picture extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'picture', 'user_id'];

    /**
     * @return HasMany
     */
    public function comments()
    {
        return $this->hasMany(Comment::class);
    }

    /**
     * @return BelongsTo
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/Admin/PictureController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\AdminPicturesTableEditRequest;
use App\Http\Requests\AdminPicturesTableStoreRequest;
use App\Models\Picture;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class PictureController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index()
    {
        $pictures = Picture::all();
        return view('admin.pictures.index', compact('pictures'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create()
    {
        $users = User::all();
        return view('admin.pictures.create', compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AdminPicturesTableStoreRequest $request
     * @return RedirectResponse
     */
    public function store(AdminPicturesTableStoreRequest $request)
    {
        $data = $request->all();
        $file = $request->file('picture');
        if (!is_null($file)) {
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $picture = new Picture($data);
        $picture->save();
        return redirect()->route('admin.pictures.index')->with('success', __('Successfully created'));
    }

    /**
     * Display the specified resource.
     *
     * @param Picture $picture
     * @return Application|Factory|View
     */
    public function show(Picture $picture)
    {
        return view('admin.pictures.show', ['picture' => $picture]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Picture $picture
     * @return Application|Factory|View
     */
    public function edit(Picture $picture)
    {
        $users = User::all();
        return view('admin.pictures.edit', ['picture' => $picture], compact('users'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param AdminPicturesTableEditRequest $request
     * @param Picture $picture
     * @return RedirectResponse
     */
    public function update(AdminPicturesTableEditRequest $request, Picture $picture)
    {
        $data = $request->all();
        if ($request->hasFile('picture')) {
            $file = $request->file('picture');
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $picture->update($data);
        return redirect()->route('admin.pictures.index')->with('success', __('Successfully created'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Picture $picture
     * @return RedirectResponse
     */
    public function destroy(Picture $picture)
    {
        $picture->delete();
        return redirect()->back()->with('success', __('Successfully deleted'));
    }
}

app/Http/Controllers/Api/PictureController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\PictureResource;
use App\Models\Picture;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;

class PictureController extends Controller
{
    /**
     * ArticleController constructor.
     */
    public function __construct()
    {
        return $this->middleware('auth:api');
    }
    /**
     * Display a listing of the resource.
     *
     * @return AnonymousResourceCollection
     */
    public function index()
    {
        $pictures = Picture::paginate(4);
        return PictureResource::collection($pictures);
    }
}

app/Http/Controllers/PictureController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PicturesTableStoreRequest;
use App\Models\Picture;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;

class PictureController extends Controller
{

    /**
     * PictureController constructor.
     */
    public function __construct()
    {
        return $this->middleware('auth')->only('create');
    }

    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index()
    {
        $pictures = Picture::orderByDesc('created_at')->paginate(4);
        return view('client.pictures.index', compact('pictures'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create()
    {
        return view('client.pictures.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param PicturesTableStoreRequest $request
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function store(PicturesTableStoreRequest $request)
    {
        $this->authorize('create', User::class);
        $data = $request->all();
        $file = $request->file('picture');
        if (!is_null($file)) {
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $picture = new Picture($data);
        $picture->user_id = Auth::id();
        $picture->save();
        return redirect()->route('users.show', ['user' => Auth::user()])->with('success', __('Successfully created'));
    }

    /**
     * Display the specified resource.
     *
     * @param Picture $picture
     * @return Application|Factory|View
     */
    public function show(Picture $picture)
    {
        $grade = round($picture->comments()->avg('grade'), 2);
        $comments = $picture->comments()->latest()->get();
        return view('client.pictures.show', ['picture' => $picture], compact('grade', 'comments'));
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Picture $picture
     * @return RedirectResponse
     */
    public function destroy(Picture $picture)
    {
        $this->authorize('delete', $picture);
        $picture->delete();
        return redirect()->route('users.show', ['user' => Auth::user()])->with('success', __('Successfully deleted'));
    }
}

resources/views/client/pictures/create.blade.php
@extends('layouts.app')
@section('content')
    <h3 class="mb-3">{{__('Create picture')}}</h3>
    <form action="{{route('pictures.store')}}" method="post" enctype="multipart/form-data">
        @csrf
        <div class="input-group mb-3">
            <span class="input-group-text" id="name">{{__('Name')}}</span>
            <input id="name" name="name" type="text" class="form-control @if($errors->has('name')) is-invalid @endif" placeholder="Username" aria-label="Username" aria-describedby="name">
        </div>
        @error('name')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <div class="mb-3">
            <label for="picture" class="form-label @if($errors->has('picture')) is-invalid @endif">{{__('Picture')}}</label>
            <input name="picture" class="form-control" type="file" id="picture">
        </div>
        @error('picture')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <div class="form-group">
            <button type="submit" class="btn btn-primary">{{ __('Save') }}</button>
        </div>
    </form>
@endsection

resources/views/client/pictures/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="row row-cols-1 row-cols-md-4">
        @foreach($pictures as $picture)
            <div class="col mb-4">
                <div class="card text-center">
                    <img style="width: 100%; height: 400px" src="{{asset('/storage/' . $picture->picture)}}"
                         class="card-img-top" alt="...">
                    <div class="card-body">
                        <h5>{{ __('Author') }}: <a
                                href="{{ route('users.show', ['user' => $picture->user ]) }}">{{$picture->user->name}}</a>
                        </h5>    <h5 class="card-title"></h5>
                        <h4><a href="{{ route('pictures.show', ['picture' => $picture ]) }}">{{$picture->name}}</a></h4>
                    </div>
                </div>
            </div>
        @endforeach
    </div>

    <div class="row justify-content-md-center p-5">
        <div class="col-md-auto">
            {{ $pictures->appends(['sort' => 'created_at'])->links('pagination::bootstrap-4') }}
        </div>
    </div>

@endsection

resources/views/client/pictures/show.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <img src="{{asset('/storage/' . $picture->picture)}}" class="card-img-top" alt="...">
        <div class="card-body">
            <p class="card-text">{{$picture->name}}</p>
            <h4>{{__('Average score')}}: {{$grade}}</h4>
        </div>
    </div>

    @can('restore', $picture)
        <div class="mt-5">
            <h4>{{ __('Add Comment') }}</h4>
            <form action="{{route('comments.store')}}" method="POST">
                @csrf
                <input name="picture_id" type="hidden" value="{{$picture->id}}">
                <div class="mb-3">
                    <label for="content" class="form-label">{{__('Content')}}</label>
                    <input name="content" type="text"
                           class="form-control @if($errors->has('content')) is-invalid @endif"
                           id="content" aria-describedby="content">
                    <div id="content" class="form-text">Please, enter your comment</div>
                    @error('content')
                    <p class="text-danger">{{$message}}</p>
                    @enderror
                </div>
                <label for="grade" class="form-label">{{__('Grade')}}</label>
                <select name="grade" class="form-select mb-3 w-25 @if($errors->has('grade')) is-invalid @endif"
                        aria-label="Default select example">
                    <option selected>Open this select menu</option>
                    <option value="1">1</option>
                    <option value="2">2</option>
                    <option value="3">3</option>
                    <option value="4">4</option>
                    <option value="5">5</option>
                </select>
                @error('grade')
                <p class="text-danger">{{$message}}</p>
                @enderror
                <button type="submit" class="btn btn-primary">{{ __('Save') }}</button>
            </form>
        </div>
    @endcan


    @foreach($comments as $comment)
        <div class="card mt-3">

            <div class="card-header d-flex">
                @can('delete', $comment)
                    <form method="POST" action="{{route('comments.destroy', ['comment' => $comment])}}">
                        @csrf
                        @method('DELETE')
                        <button class="btn btn-outline-danger" type="submit">{{ __('Delete') }}</button>
                    </form>
                @endcan
                @can('update', $comment)
                    <a class=" mx-3 btn btn-outline-success"
                       href="{{route('comments.edit', ['comment' => $comment])}}">{{ __('Edit') }}</a>
                @endcan
            </div>
            <div class="card-body">
                <h5>{{$comment->user->name}}</h5>
                <h6>{{__('Grade')}}: {{$comment->grade}}</h6>
                <p class="card-text">{{$comment->content}}</p>
                <p>{{$comment->created_at->diffForHumans()}}</p>
            </div>
        </div>
    @endforeach

@endsection